//----------------------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//----------------------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  DarkOrange
#property indicator_color3  LimeGreen
#property indicator_color4  DarkOrange
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern int SmoothPeriod1 = 6;
extern int SmoothPeriod2 = 30;
double bufferHc1[];
double bufferHo1[];
double bufferHh1[];
double bufferHl1[];
double bufferHc2[];
double bufferHo2[];
double bufferHh2[];
double bufferHl2[];

//----------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,bufferHh1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,bufferHl1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,bufferHc1); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,bufferHo1); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,bufferHh2);
   SetIndexBuffer(5,bufferHl2);
   SetIndexBuffer(6,bufferHc2);
   SetIndexBuffer(7,bufferHo2);
   
   //
   //
   //
   //
   //
      
   return(0);
}
int deinit()
{
   return(0);
}

//----------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------
//
//
//
//
//

double working[][4];
#define _haOpen  0
#define _haClose 1
#define _haHigh  2
#define _haLow   3

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      int i,r,limit;
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(working,0) != Bars) ArrayResize(working,Bars);

   //
   //
   //
   //
   //
        
   for(i=limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      working[r][_haOpen]  = iSsm(iMA(NULL,0,1,0,MODE_SMA,PRICE_OPEN ,i),SmoothPeriod1,i,0);
      working[r][_haClose] = iSsm(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i),SmoothPeriod1,i,1);
      working[r][_haHigh]  = iSsm(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH ,i),SmoothPeriod1,i,2);
      working[r][_haLow]   = iSsm(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW  ,i),SmoothPeriod1,i,3);
      
      //
      //
      //
      //
      //
      
      double haOpen  = (bufferHo2[i+1]+bufferHc2[i+1])/2.0; 
      double haClose = (working[r][_haOpen]+working[r][_haClose]+working[r][_haHigh]+working[r][_haLow])/4.0;
      double haHigh  = MathMax(working[r][_haHigh],MathMax(haOpen,haClose));
      double haLow   = MathMin(working[r][_haLow] ,MathMin(haOpen,haClose));

      if (haOpen<haClose) 
         {
            bufferHl2[i]=haLow;
            bufferHh2[i]=haHigh;
         } 
      else
         {
            bufferHh2[i]=haLow;
            bufferHl2[i]=haHigh;
         }
      bufferHo2[i]=haOpen;
      bufferHc2[i]=haClose;
      bufferHo1[i]=iSsm(bufferHo2[i],SmoothPeriod2,i,4);
      bufferHc1[i]=iSsm(bufferHc2[i],SmoothPeriod2,i,5);
      bufferHh1[i]=iSsm(bufferHh2[i],SmoothPeriod2,i,6);
      bufferHl1[i]=iSsm(bufferHl2[i],SmoothPeriod2,i,7);
   }
   
   //
   //
   //
   //
   //
   
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSsm[][16];
#define _price  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo)
{
   if (period<=1) return(price);
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      i = Bars-i-1;
      int s = instanceNo*2;   
          workSsm[i][s+_price] = price;
          workSsm[i][s+_ssm]   = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 + 
                                 workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                              + 
                                 workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
   return(workSsm[i][s+_ssm]);
}